package ucot.heuristic;
import java.util.Properties;

import ucot.model.AnalyzeModel;
import ucot.parser.ParsedData;

public interface HeuristicInterface {	
	/**
	 * Performs heuristic on given ParsedData object returns 
	 * @param data Parsed usecase for the heuristic
	 * @param model analyze model where parseddata is added to
	 */
	void doHeuristic(ParsedData data, AnalyzeModel model) throws Exception;
	
	/**
	 * Returns adapter's name
	 * @return
	 */
	String getName();
	
	/**
	 * Sets options for the adapter
	 * @param options options for the adapter
	 */
	void setOptions(Properties options);
	
	/**
	 * Returns adapter's options
	 * @return adapter's options
	 */
	Properties getOptions();
}
