package ucot.input;

import java.net.URL;
import java.util.Vector;

public class InputCollection {
	
	private Vector<InputInterface> inputs = new Vector<InputInterface>();
	
	public InputCollection() {
		inputs.add(new SimpleInputAdapter());		
	}
	
	/**
	 * Returns input that can read file on given url
	 * @param url of the file we want to read
	 * @return InputInterface that can read file or null if none can
	 */
	public InputInterface getInputForUrl(URL url) {
		for(int i=0;i<getInputCount();i++) {
			if (getInput(i).canRead(url))
				return getInput(i);
		}		
		return null;
	}
	
	public int getInputCount() {
		return inputs.size();
	}
	
	public InputInterface getInput(int index) {
		return inputs.get(index);
	}
}
