package ucot.model;

public class Relation extends Thing{
    Thing from;
    Thing to;
    RelationType type;
    String name;
    
    public Relation(Thing from, String name, Thing to) {
        super(name,"relation");
        type = RelationType.INFLUENCE;
        this.from = from;
        this.to = to;
    }
    
    public Relation(Thing from, RelationType type, Thing to) {
        super(type.toString(),"relation");
        this.type = type;
        this.from = from;
        this.to = to;
    }
    
    public Thing getFrom() {
        return from;
    }
    public void setFrom(Item from) {
        this.from = from;
    }
   
    public Thing getTo() {
        return to;
    }
    public void setTo(Item to) {
        this.to = to;
    }
    public RelationType getType() {
        return type;
    }
    public void setType(RelationType type) {
        this.type = type;
    }
    
    public boolean equals(Object o){
        if (o instanceof Relation){
            Relation r = (Relation) o;
            return 
            r.getType().equals(getType()) 
            && r.getName().equals(getName()) 
            && r.getTo().equals(getTo()) 
            && r.getFrom().equals(getFrom());
        }
        return false;
    }
    
   
    public int hashCode() {
        String tmp = getFrom()+getName()+getTo()+getType().toString();
        return tmp.hashCode();
    }
    public String toString(){
        return from.toString() +" - " + getName() + " -> " + getTo();
    }
}
