package ucot.parser;

import java.util.List;
import java.util.Vector;

import ucot.input.UseCase;

public class ParsedData {

    List<Sentence> sentences = new Vector<Sentence>();
    private UseCase usecase = null;
    
    public void setUseCase(UseCase a) {
    	usecase = a;
    }
    
    public UseCase getUseCase() {
    	return usecase;
    }
    
    public ParsedData() {}
    
    public void addSentence(Sentence s) {
        sentences.add(s);
    }
    
    public List<Sentence> getSentences(){
        Vector<Sentence> ret = new Vector<Sentence>();
        ret.addAll(sentences);
        return ret;
    }
    

    public String toString() {
        StringBuffer buffer = new StringBuffer();
        buffer.append("ParsedData:\n");
        for(Sentence sentence : sentences){
            buffer.append(sentence);
            buffer.append("\n");
        }
        return buffer.toString();
    }

    
    /**
     * Returns the text of the original use case.
     * @return
     */
    public String getOriginal(){
            StringBuffer buffer = new StringBuffer();
            for(Sentence sentence : sentences){
                for(Word word : sentence.getWords()){
                    buffer.append(word.getOriginal());
                    buffer.append(" ");
                }
                buffer.append("\n");
            }
            return buffer.toString();

    }

}
