package ucot.parser;
import java.util.Properties;

import ucot.input.UseCase;

public interface ParserInterface {
	/**
	 * Parses given usecase and returns parsed data as a ParsedData object.
	 * @param usecase Usecase to parse
	 * @return parsed data as a ParsedData object.
	 */
	ParsedData parse( UseCase useCase) throws Exception;
	
	/**
	 * Returns adapter's name
	 * @return
	 */
	String getName();
	
	/**
	 * Sets options for the adapter
	 * @param options options for the adapter
	 */
	void setOptions(Properties options);
	
	/**
	 * Returns adapter's options
	 * @return adapter's options
	 */
	Properties getOptions();
}
