package ucot.test;

import junit.framework.Assert;
import java.net.URL;
import java.net.MalformedURLException;

import org.junit.Test;

import ucot.core.Core;
import ucot.input.*;

public class CoreTest {
	Core core = new Core();
	
	@Test
	public void testCoreShutdownAndStartup() {
		Assert.assertNotNull(core);
		core.shutdown();
		Assert.assertEquals(0, core.getAnalyzeModels().size());
		Assert.assertEquals(0, core.getUseCaseCollection().getUseCaseCount());
		core = new Core();
	}
	
	@Test
	public void testUseCaseLoading() {
		URL testData = null;
		String testFile = "Core-loadUseCase-Test.dat";
		try {
		    testData = new URL("file", "", -1, testFile);
		} catch (MalformedURLException murle) {
			System.out.println("Missing Test Data file: " + testFile);
		}
		
		core.loadUseCases(testData);
		UseCaseCollection collection = core.getUseCaseCollection();
		for ( int i = 0; i < collection.getUseCaseCount(); i++ ) {
			System.out.println(collection.getUseCase(i).getName());
		}
	}
}
