package ucot.ui.gui.tree;

import java.util.List;
import java.util.Set;
import java.util.Vector;

import ucot.model.Entity;
import ucot.model.Method;
import ucot.model.Relation;
import ucot.model.Thing;

public class MethodTreeItem extends TreeItem {
	Method method;
	public MethodTreeItem(AnalyzeTreeModel model, TreeItem parent, Method method) {
		super(model,parent);
		this.method = method;		
	}
	
	public String getName() {
		return method.getName();
	}
	
	
	public Object getData() {
		return method;
	}
	public List getChildren() {
		List<TreeItem> items = new Vector<TreeItem>();
		Set<Relation> relationsToMethod = getAnalyzeModel().getRelationsTo(method);
		assert relationsToMethod.size() == 1;
		Relation rel = relationsToMethod.iterator().next();
		Entity owner = (Entity) rel.getFrom();
		
		Set<Relation> relationsFrom = getAnalyzeModel().getRelationsFrom(owner, Entity.TYPE_NAME);
		for(Relation relation : relationsFrom){
			if (relation.getName().equals(method.getName())){
				Entity toEntity = (Entity) relation.getTo();
				TreeItem item = new EntityTreeItem(getTreeModel(), this,toEntity, false);
				items.add(item);
			}
		}
		return items;
	}
	
	public List<TreeItem> getRelevants(Thing thing){
		List<TreeItem> ret = new Vector<TreeItem>();
		if (thing instanceof Relation){
			Relation relation = ((Relation) thing);
			if (relation.getName().equals(method.getName()))	
				ret.add(this);
			
			
		}
		return ret;
	}
}
