package ucot.ui.gui.tree;

import java.util.List;
import java.util.Set;
import java.util.Vector;

import ucot.model.Entity;
import ucot.model.Method;
import ucot.model.Relation;

public class MethodsTreeItem extends TreeItem {
	Entity entity;
	
	
	public MethodsTreeItem(AnalyzeTreeModel model, TreeItem parent,Entity entity) {
		super(model,parent);
		this.entity = entity;
	}
	
	public String getName() {
		return "methods";
	}
	
	public Object getData() {
		return getName();
	}
	
	public List getChildren() {
		List<TreeItem> items = new Vector<TreeItem>();
		Set<Relation> methodRelations = getAnalyzeModel().getRelationsFrom(entity, Method.TYPE_NAME);
		for (Relation r : methodRelations) {
			TreeItem method = new MethodTreeItem(getTreeModel(),this,(Method) r.getTo());
			items.add(method);
		}
		return items;
	}
}
