package ucot.ui.gui.tree;

import java.util.List;
import java.util.Vector;

import ucot.model.AnalyzeModel;
import ucot.model.Thing;

public abstract class TreeItem{
	Object data;
	String name;
	AnalyzeTreeModel model;
	TreeItem parent;
	public TreeItem(AnalyzeTreeModel model, TreeItem parent){
		this.model = model;
		this.parent = parent;
	}
	
	public AnalyzeTreeModel getTreeModel(){
		return model;
	}
	
	public AnalyzeModel getAnalyzeModel(){
		if (model != null)
			return model.getAnalyzeModel();
		else return null;
	}
	
	public boolean equals(Object o){
		if (o instanceof TreeItem){
			TreeItem item = (TreeItem) o;
			return getData().equals(item.getData());
		}
		return false;
	}
	
	public abstract String getName();
	public abstract Object getData();
	
	public String toString(){
		return getName();
	}
	
	public List<TreeItem> getChildren(){
		return new Vector<TreeItem>();
	}
	
	public List<TreeItem> getRelevants(Thing thing){
		List<TreeItem> children = getChildren();
		List<TreeItem> ret = new Vector<TreeItem>();
		for(TreeItem item : children){
			ret.addAll(item.getRelevants(thing));
		}
		return ret;
	}
	
	public List<TreeItem> getPath(){
		List<TreeItem> path = new Vector<TreeItem>();
		path.add(0,this);
		if (parent != null){path.addAll(0,parent.getPath());}
		return path;
	}
	
}
